<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.srs.flowable.mapper.EnlistmentReserveApprovalMapper">

    <resultMap type="EnlistmentReserveApproval" id="RtEnlistmentReserveApprovalResult">
        <result property="id"    column="id"    />
        <result property="applyId"    column="apply_id"    />
        <result property="processInstanceId"    column="process_instance_id"    />
        <result property="taskId"    column="task_id"    />
        <result property="nodeName"    column="node_name"    />
        <result property="approverId"    column="approver_id"    />
        <result property="approverName"    column="approver_name"    />
        <result property="approvalOpinion"    column="approval_opinion"    />
        <result property="approvalResult"    column="approval_result"    />
        <result property="approvalTime"    column="approval_time"    />
        <result property="studentName"    column="student_name"    />
        <result property="studentNo"    column="student_no"    />
    </resultMap>

    <sql id="selectRtEnlistmentReserveApprovalVo">
        select id, apply_id, process_instance_id, task_id, node_name, approver_id, approver_name, approval_opinion, approval_result, approval_time, student_name, student_no from rt_enlistment_reserve_approval
    </sql>

    <select id="selectRtEnlistmentReserveApprovalList" parameterType="EnlistmentReserveApproval" resultMap="RtEnlistmentReserveApprovalResult">
        <include refid="selectRtEnlistmentReserveApprovalVo"/>
        <where>
            <if test="applyId != null "> and apply_id = #{applyId}</if>
            <if test="processInstanceId != null  and processInstanceId != ''"> and process_instance_id = #{processInstanceId}</if>
            <if test="taskId != null  and taskId != ''"> and task_id = #{taskId}</if>
            <if test="nodeName != null  and nodeName != ''"> and node_name like concat('%', #{nodeName}, '%')</if>
            <if test="approverId != null "> and approver_id = #{approverId}</if>
            <if test="approverName != null  and approverName != ''"> and approver_name like concat('%', #{approverName}, '%')</if>
            <if test="approvalOpinion != null  and approvalOpinion != ''"> and approval_opinion = #{approvalOpinion}</if>
            <if test="approvalResult != null "> and approval_result = #{approvalResult}</if>
            <if test="approvalTime != null "> and approval_time = #{approvalTime}</if>
            <if test="studentName != null  and studentName != ''"> and student_name like concat('%', #{studentName}, '%')</if>
            <if test="studentNo != null  and studentNo != ''"> and student_no = #{studentNo}</if>
        </where>
    </select>

    <select id="selectRtEnlistmentReserveApprovalById" parameterType="Long" resultMap="RtEnlistmentReserveApprovalResult">
        <include refid="selectRtEnlistmentReserveApprovalVo"/>
        where id = #{id}
    </select>

    <select id="selectRtEnlistmentReserveApprovalByStuName" resultMap="RtEnlistmentReserveApprovalResult">
        select *
        from rt_enlistment_reserve_approval
        <where>
            <if test="studentName != null and studentName != ''">
                and student_name = #{studentName}
            </if>
            <if test="studentNo != null and studentNo != ''">
                and student_no = #{studentNo}
            </if>
            <if test="approverId != null and approverId != ''">
                and approver_id = #{approverId}
            </if>
        </where>
    </select>

    <insert id="insertRtEnlistmentReserveApproval" parameterType="RtEnlistmentReserveApproval" useGeneratedKeys="true" keyProperty="id">
        insert into rt_enlistment_reserve_approval
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="applyId != null">apply_id,</if>
            <if test="processInstanceId != null and processInstanceId != ''">process_instance_id,</if>
            <if test="taskId != null and taskId != ''">task_id,</if>
            <if test="nodeName != null and nodeName != ''">node_name,</if>
            <if test="approverId != null">approver_id,</if>
            <if test="approverName != null and approverName != ''">approver_name,</if>
            <if test="approvalOpinion != null">approval_opinion,</if>
            <if test="approvalResult != null">approval_result,</if>
            <if test="approvalTime != null">approval_time,</if>
            <if test="studentName != null and studentName != ''">student_name,</if>
            <if test="studentNo != null and studentNo != ''">student_no,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="applyId != null">#{applyId},</if>
            <if test="processInstanceId != null and processInstanceId != ''">#{processInstanceId},</if>
            <if test="taskId != null and taskId != ''">#{taskId},</if>
            <if test="nodeName != null and nodeName != ''">#{nodeName},</if>
            <if test="approverId != null">#{approverId},</if>
            <if test="approverName != null and approverName != ''">#{approverName},</if>
            <if test="approvalOpinion != null">#{approvalOpinion},</if>
            <if test="approvalResult != null">#{approvalResult},</if>
            <if test="approvalTime != null">#{approvalTime},</if>
            <if test="studentName != null and studentName != ''">#{studentName},</if>
            <if test="studentNo != null and studentNo != ''">#{studentNo},</if>
        </trim>
    </insert>

    <update id="updateRtEnlistmentReserveApproval" parameterType="RtEnlistmentReserveApproval">
        update rt_enlistment_reserve_approval
        <trim prefix="SET" suffixOverrides=",">
            <if test="applyId != null">apply_id = #{applyId},</if>
            <if test="processInstanceId != null and processInstanceId != ''">process_instance_id = #{processInstanceId},</if>
            <if test="taskId != null and taskId != ''">task_id = #{taskId},</if>
            <if test="nodeName != null and nodeName != ''">node_name = #{nodeName},</if>
            <if test="approverId != null">approver_id = #{approverId},</if>
            <if test="approverName != null and approverName != ''">approver_name = #{approverName},</if>
            <if test="approvalOpinion != null">approval_opinion = #{approvalOpinion},</if>
            <if test="approvalResult != null">approval_result = #{approvalResult},</if>
            <if test="approvalTime != null">approval_time = #{approvalTime},</if>
            <if test="studentName != null and studentName != ''">student_name = #{studentName},</if>
            <if test="studentNo != null and studentNo != ''">student_no = #{studentNo},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteRtEnlistmentReserveApprovalById" parameterType="Long">
        delete from rt_enlistment_reserve_approval where id = #{id}
    </delete>

    <delete id="deleteRtEnlistmentReserveApprovalByIds" parameterType="String">
        delete from rt_enlistment_reserve_approval where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>